/**
 * This entity describes the role an author has in a work.
 * Examples: story writing, drawing, animating, publishing, ...
 */
interface AuthorRoleInterface extends IdentifiableInterface, MultiNamedInterface, DescribableInterface {
  names: Promise<AuthorRoleNameInterface[]> | Identifier[];

  /**
   * relation to the entity connecting with the author and work
   */
  workAuthors: Promise<WorkAuthorInterface[]> | Identifier[];
}
