/**
 * This tag entity tags an interaction between two characters.
 */
interface InteractionTagInterface extends IdentifiableInterface, WeightedInterface {
  /**
   * the describing tag
   */
  tag: Promise<TagInterface> | Identifier;

  /**
   * the actors of this interaction
   */
  subjectCharacters: Promise<WorkCharacterInterface[]> | Identifier[];

  /**
   * the receivers of this interaction
   */
  objectCharacters: Promise<WorkCharacterInterface[]> | Identifier[];
}
