/**
 * This entity describes a transformation type.
 * Possible type: translation, decensor, collection, ...
 */
interface TransformationTypeInterface extends IdentifiableInterface, MultiNamedInterface, DescribableInterface {
  names: Promise<TransformationTypeNameInterface[]> | Identifier[];

  /**
   * the transformations of this type
   */
  transformations: Promise<TransformationInterface[]> | Identifier[];

  /**
   * if that transformation conserves the tags of the original work
   */
  conservesTags: boolean;
}
