/**
 * This entity describes how one work is transformed to another.
 */
interface TransformationInterface extends IdentifiableInterface, OrderableInterface {
  /**
   * the work based on the original
   */
  byWork: Promise<WorkInterface> | Identifier;

  /**
   * the transformation type
   */
  type: Promise<TransformationTypeInterface> | Identifier;

  /**
   * the original work, it being null meaning that the original work is unknown
   */
  ofWork: Promise<WorkInterface> | Identifier | null;
}
