/**
 * This entity describes a canon character in a fictional world.
 */
interface WorldCharacterInterface
  extends IdentifiableInterface,
    MultiNamedInterface,
    HierarchicalInterface<WorldCharacterInterface> {
  names: Promise<WorldCharacterNameInterface[]> | Identifier[];

  /**
   * the characters in works which are based on this one
   */
  workCharacters: Promise<WorkCharacterInterface[]> | Identifier[];

  /**
   * the fictional worlds this character is a part of
   */
  worlds: Promise<WorldInterface[]> | Identifier[];
}
