/**
 * This entity describes a fictional world.
 */
interface WorldInterface extends IdentifiableInterface, MultiNamedInterface, HierarchicalInterface<WorldInterface> {
  names: Promise<WorldNameInterface[]> | Identifier[];

  /**
   * works taking place in this world
   */
  works: Promise<WorkInterface[]> | Identifier[];

  /**
   * canon characters in this world
   */
  worldCharacters: Promise<WorldCharacterInterface[]> | Identifier[];
}
